Index: trunk/NEMO/OPA_SRC/TRA/traldf.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traldf.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRA/traldf.F90	(revision 503)
@@ -4,6 +4,7 @@
    !! Ocean Active tracers : lateral diffusive trends 
    !!=====================================================================
-   !! History :
-   !!   9.0  !  05-11  (G. Madec)  Original code
+   !! History :  9.0  ! 05-11 (G. Madec)  Original code
+   !!----------------------------------------------------------------------
+
    !!----------------------------------------------------------------------
    !!   tra_ldf     : update the tracer trend with the lateral diffusion
@@ -11,5 +12,4 @@
    !!       ldf_ano : compute lateral diffusion for constant T-S profiles
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
@@ -31,15 +31,10 @@
    PRIVATE
 
-   !! *  Routine accessibility
-   PUBLIC tra_ldf      ! called by step.F90 
-
-   !! * module variables
-   INTEGER ::                        & 
-      nldf = 0                         ! type of lateral diffusion used
-      !                                ! defined from ln_traldf_... namlist logicals)
+   PUBLIC   tra_ldf    ! called by step.F90 
+
+   INTEGER ::   nldf = 0   ! type of lateral diffusion used defined from ln_traldf_... namlist logicals)
 #if defined key_traldf_ano
-   REAL, DIMENSION(jpi,jpj,jpk) ::   &  
-      t0_ldf, s0_ldf                    ! lateral diffusion trends of T & S
-      !                                 ! for a constant vertical profile
+   REAL, DIMENSION(jpi,jpj,jpk) ::   t0_ldf, s0_ldf   ! lateral diffusion trends of T & S
+      !                                               ! for a constant vertical profile
 #endif
 
@@ -47,7 +42,9 @@
 #  include "domzgr_substitute.h90"
 #  include "vectopt_loop_substitute.h90"
-   !!---------------------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !!---------------------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $Header$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 
 CONTAINS
@@ -60,13 +57,10 @@
       !!
       !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
-
-      !! * local declarations
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-         ztrdt, ztrds                         ! 3D temporary workspace
-      !!----------------------------------------------------------------------
-
-      IF( kt == nit000 )   CALL ldf_ctl      ! initialisation & control of options
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
+      !!
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrdt, ztrds   ! 3D temporary workspace
+      !!----------------------------------------------------------------------
+
+      IF( kt == nit000 )   CALL ldf_ctl          ! initialisation & control of options
 
       IF( l_trdtra )   THEN                      ! temporary save of ta and sa trends
@@ -76,5 +70,10 @@
 
       SELECT CASE ( nldf )                       ! compute lateral mixing trend and add it to the general trend
-      CASE ( -1 )                                       ! esopa: test all possibility with control print
+      CASE ( 0 )   ;   CALL tra_ldf_lap   ( kt )      ! iso-level laplacian
+      CASE ( 1 )   ;   CALL tra_ldf_iso   ( kt )      ! rotated laplacian (except dk[ dk[.] ] part)
+      CASE ( 2 )   ;   CALL tra_ldf_bilap ( kt )      ! iso-level bilaplacian
+      CASE ( 3 )   ;   CALL tra_ldf_bilapg( kt )      ! s-coord. horizontal bilaplacian
+         !
+      CASE ( -1 )                                     ! esopa: test all possibility with control print
          CALL tra_ldf_lap    ( kt )
          CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf0 - Ta: ', mask1=tmask,               &
@@ -89,32 +88,19 @@
          CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf3 - Ta: ', mask1=tmask,               &
             &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-
-      CASE ( 0 )                                       ! iso-level laplacian
-         CALL tra_ldf_lap    ( kt )
-      CASE ( 1 )                                       ! rotated laplacian (except dk[ dk[.] ] part)
-         CALL tra_ldf_iso    ( kt )
-      CASE ( 2 )                                       ! iso-level bilaplacian
-         CALL tra_ldf_bilap  ( kt )
-      CASE ( 3 )                                       ! s-coord. horizontal bilaplacian
-         CALL tra_ldf_bilapg ( kt )
       END SELECT
 
 #if defined key_traldf_ano
-      !                                          ! anomaly: substract the reference diffusivity
-      ta(:,:,:) = ta(:,:,:) - t0_ldf(:,:,:)
+      ta(:,:,:) = ta(:,:,:) - t0_ldf(:,:,:)      ! anomaly: substract the reference diffusivity
       sa(:,:,:) = sa(:,:,:) - s0_ldf(:,:,:)
 #endif
-
-      !                                          ! save the horizontal diffusive trends for further diagnostics
-      IF( l_trdtra )   THEN
+      IF( l_trdtra )   THEN                      ! save the horizontal diffusive trends for further diagnostics
          ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
          ztrds(:,:,:) = sa(:,:,:) - ztrds(:,:,:)
-         CALL trd_mod( ztrdt, ztrds, jpttdldf, 'TRA', kt )
-      ENDIF
-
+         CALL trd_mod( ztrdt, ztrds, jptra_trd_ldf, 'TRA', kt )
+      ENDIF
       !                                          ! print mean trends (used for debugging)
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf  - Ta: ', mask1=tmask,               &
          &                       tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-
+      !
    END SUBROUTINE tra_ldf
 
@@ -132,7 +118,5 @@
       !!      nldf ==  2   bilaplacian operator
       !!      nldf ==  3   Rotated bilaplacian
-      !!
-      !!----------------------------------------------------------------------
-      !! * Local declarations
+      !!----------------------------------------------------------------------
       INTEGER ::   ioptio, ierr         ! temporary integers 
 !      
@@ -150,28 +134,26 @@
 !     READ  ( numnam, nam_traldf )
 
-      IF(lwp) THEN
+      IF(lwp) THEN                    ! Namelist print
          WRITE(numout,*)
          WRITE(numout,*) 'tra:ldf_ctl : lateral tracer diffusive operator'
          WRITE(numout,*) '~~~~~~~~~~~'
-         WRITE(numout,*) '          Namelist nam_traldf : set lateral mixing parameters (type, direction, coefficients)'
-         WRITE(numout,*) '             laplacian operator          ln_traldf_lap   = ', ln_traldf_lap
-         WRITE(numout,*) '             bilaplacian operator        ln_traldf_bilap = ', ln_traldf_bilap
-         WRITE(numout,*) '             iso-level                   ln_traldf_level = ', ln_traldf_level
-         WRITE(numout,*) '             horizontal (geopotential)   ln_traldf_hor   = ', ln_traldf_hor
-         WRITE(numout,*) '             iso-neutral                 ln_traldf_iso   = ', ln_traldf_iso
-      ENDIF
-
-      ! Parameter control
-
-      ! control the input
+         WRITE(numout,*) '       Namelist nam_traldf : set lateral mixing parameters (type, direction, coefficients)'
+         WRITE(numout,*) '          laplacian operator          ln_traldf_lap   = ', ln_traldf_lap
+         WRITE(numout,*) '          bilaplacian operator        ln_traldf_bilap = ', ln_traldf_bilap
+         WRITE(numout,*) '          iso-level                   ln_traldf_level = ', ln_traldf_level
+         WRITE(numout,*) '          horizontal (geopotential)   ln_traldf_hor   = ', ln_traldf_hor
+         WRITE(numout,*) '          iso-neutral                 ln_traldf_iso   = ', ln_traldf_iso
+      ENDIF
+
+      !                               ! control the input
       ioptio = 0
       IF( ln_traldf_lap   )   ioptio = ioptio + 1
       IF( ln_traldf_bilap )   ioptio = ioptio + 1
-      IF( ioptio /= 1 ) CALL ctl_stop( '          use ONE of the 2 lap/bilap operator type on tracer' )
+      IF( ioptio /= 1 )   CALL ctl_stop( '          use ONE of the 2 lap/bilap operator type on tracer' )
       ioptio = 0
       IF( ln_traldf_level )   ioptio = ioptio + 1
       IF( ln_traldf_hor   )   ioptio = ioptio + 1
       IF( ln_traldf_iso   )   ioptio = ioptio + 1
-      IF( ioptio /= 1 ) CALL ctl_stop( '          use only ONE direction (level/hor/iso)' )
+      IF( ioptio /= 1 )   CALL ctl_stop( '          use only ONE direction (level/hor/iso)' )
 
       ! defined the type of lateral diffusion from ln_traldf_... logicals
@@ -213,11 +195,11 @@
       ENDIF
 
-      IF( ierr == 1 ) CALL ctl_stop( ' iso-level in z-coordinate - partial step, not allowed' )
-      IF( ierr == 2 ) CALL ctl_stop( ' isoneutral bilaplacian operator does not exist' )
-      IF( lk_traldf_eiv .AND. .NOT.ln_traldf_iso ) &
-           & CALL ctl_stop( '          eddy induced velocity on tracers', &
-           &                ' the eddy induced velocity on tracers requires isopycnal laplacian diffusion' )
+      IF( ierr == 1 )   CALL ctl_stop( ' iso-level in z-coordinate - partial step, not allowed' )
+      IF( ierr == 2 )   CALL ctl_stop( ' isoneutral bilaplacian operator does not exist' )
+      IF( lk_traldf_eiv .AND. .NOT.ln_traldf_iso )   &
+           CALL ctl_stop( '          eddy induced velocity on tracers',   &
+           &              ' the eddy induced velocity on tracers requires isopycnal laplacian diffusion' )
       IF( nldf == 1 .OR. nldf == 3 ) THEN      ! rotation
-         IF( .NOT.lk_ldfslp ) CALL ctl_stop( '          the rotation of the diffusive tensor require key_ldfslp' )
+         IF( .NOT.lk_ldfslp )   CALL ctl_stop( '          the rotation of the diffusive tensor require key_ldfslp' )
       ENDIF
 
@@ -236,10 +218,8 @@
       ENDIF
 
-
       ! Reference T & S diffusivity (if necessary)
       ! ===========================
-
       CALL ldf_ano
-
+      !
    END SUBROUTINE ldf_ctl
 
@@ -254,18 +234,14 @@
       !!
       !! ** Purpose :   initializations of 
-      !!
-      !!----------------------------------------------------------------------
-      !! * Modules used
+      !!----------------------------------------------------------------------
       USE zdf_oce         ! vertical mixing
       USE trazdf          ! vertical mixing: double diffusion
       USE zdfddm          ! vertical mixing: double diffusion
-
-      !! * local declarations
-      INTEGER  ::   jk                         ! Dummy loop indice
-      LOGICAL  ::   llsave                     !
-      REAL(wp) ::   zt0, zs0, z12              ! temporary scalar
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-         zt_ref, ztb, zavt,                 &  ! 3D temporary workspace
-         zs_ref, zsb                           ! 3D temporary workspace
+      !!
+      INTEGER  ::   jk              ! Dummy loop indice
+      LOGICAL  ::   llsave          !
+      REAL(wp) ::   zt0, zs0, z12   ! temporary scalar
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zt_ref, ztb, zavt   ! 3D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zs_ref, zsb         ! 3D workspace
       !!----------------------------------------------------------------------
 
@@ -329,5 +305,5 @@
       sa    (:,:,:) = va  (:,:,:)
       avt   (:,:,:) = zavt(:,:,:)
-
+      !
    END SUBROUTINE ldf_ano
 
Index: trunk/NEMO/OPA_SRC/TRA/traldf_iso.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traldf_iso.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRA/traldf_iso.F90	(revision 503)
@@ -1,10 +1,16 @@
 MODULE traldf_iso
-   !!==============================================================================
+   !!======================================================================
    !!                   ***  MODULE  traldf_iso  ***
    !! Ocean active tracers:  horizontal component of the lateral tracer mixing trend
-   !!==============================================================================
+   !!======================================================================
+   !! History :        !  94-08  (G. Madec, M. Imbard)
+   !!                  !  97-05  (G. Madec)  split into traldf and trazdf
+   !!             8.5  !  02-08  (G. Madec)  Free form, F90
+   !!             9.0  !  05-11  (G. Madec)  merge traldf and trazdf :-)
+   !!----------------------------------------------------------------------
 #if   defined key_ldfslp   ||   defined key_esopa
    !!----------------------------------------------------------------------
    !!   'key_ldfslp'               slope of the lateral diffusive direction
+   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   tra_ldf_iso  : update the tracer trend with the horizontal 
@@ -14,5 +20,4 @@
    !!                  vector optimization, use k-j-i loops.
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
@@ -26,10 +31,8 @@
    USE prtctl          ! Print control
 
-
    IMPLICIT NONE
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC tra_ldf_iso   ! routine called by step.F90
+   PUBLIC   tra_ldf_iso   ! routine called by step.F90
 
    !! * Substitutions
@@ -39,4 +42,6 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -81,36 +86,21 @@
       !!         ta = ta + difft
       !!
-      !! ** Action :
-      !!         Update (ta,sa) arrays with the before rotated diffusion trend
-      !!            (except the dk[ dk[.] ] term)
-      !!
-      !! History :
-      !!        !  94-08  (G. Madec, M. Imbard)
-      !!        !  97-05  (G. Madec)  split into traldf and trazdf
-      !!   8.5  !  02-08  (G. Madec)  Free form, F90
-      !!   9.0  !  04-08  (C. Talandier) New trends organization
-      !!        !  05-11  (G. Madec)  merge traldf and trazdf :-)
-      !!----------------------------------------------------------------------
-      !! * Modules used
-      USE oce           , zftv => ua,   &  ! use ua as workspace
-         &                zfsv => va       ! use va as workspace
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt        ! ocean time-step index
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk              ! dummy loop indices
-      INTEGER ::   iku, ikv                ! temporary integer
-      REAL(wp) ::   &
-         zabe1, zabe2, zcof1, zcof2,    &  ! temporary scalars
-         zmsku, zta,                    &  !    "           "
-         zmskv, zsa, zbtr,              &  !    "           "
-         zcoef0, zcoef3, zcoef4            !    "         "
-      REAL(wp), DIMENSION(jpi,jpj) ::   &  ! temporary workspace
-         zdkt , zdk1t, zftu,            &  !    "           "
-         zdks , zdk1s, zfsu                !    "           "
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   & 
-         zdit, zdjt, ztfw,              &  ! temporary workspace
-         zdis, zdjs, zsfw                  !    "           "
+      !! ** Action :   Update (ta,sa) arrays with the before rotated diffusion
+      !!            trend (except the dk[ dk[.] ] term)
+      !!----------------------------------------------------------------------
+      USE oce           , zftv => ua   ! use ua as workspace
+      USE oce           , zfsv => va   ! use va as workspace
+      !!
+      INTEGER, INTENT( in ) ::   kt    ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      INTEGER  ::   iku, ikv     ! temporary integer
+      REAL(wp) ::   zmsku, zabe1, zcof1, zcoef3, zta   ! temporary scalars
+      REAL(wp) ::   zmskv, zabe2, zcof2, zcoef4, zsa   !    "         "
+      REAL(wp) ::   zcoef0, zbtr                       !    "         "
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zdkt , zdk1t, zftu   ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zdks , zdk1s, zfsu   !    "           "
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdit, zdjt, ztfw     ! 3D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdis, zdjs, zsfw     !  "      "
       !!----------------------------------------------------------------------
 
@@ -130,5 +120,4 @@
       zdjs (1,:,:) = 0.e0     ;     zdjs (jpi,:,:) = 0.e0
 !!end
-
 
       ! Horizontal temperature and salinity gradient 
@@ -217,5 +206,4 @@
          ! II.4 Second derivative (divergence) and add to the general trend
          ! ----------------------------------------------------------------
-
          DO jj = 2 , jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -231,6 +219,5 @@
       !                                             ! ===============
 
-      IF( ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
-         ! "zonal" mean lateral diffusive heat and salt transports
+      IF( ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN   ! Poleward diffusive heat and salt transports
          pht_ldf(:) = ptr_vj( zftv(:,:,:) )
          pst_ldf(:) = ptr_vj( zfsv(:,:,:) )
@@ -297,5 +284,5 @@
          END DO
       END DO
-
+      !
    END SUBROUTINE tra_ldf_iso
 
@@ -306,5 +293,4 @@
 CONTAINS
    SUBROUTINE tra_ldf_iso( kt )               ! Empty routine
-      INTEGER :: kt
       WRITE(*,*) 'tra_ldf_iso: You should not have seen this print! error?', kt
    END SUBROUTINE tra_ldf_iso
Index: trunk/NEMO/OPA_SRC/TRA/tranpc.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/tranpc.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRA/tranpc.F90	(revision 503)
@@ -4,4 +4,12 @@
    !! Ocean active tracers:  non penetrative convection scheme
    !!==============================================================================
+   !! History :  1.0  !  90-09  (G. Madec)  Original code
+   !!                 !  91-11  (G. Madec)
+   !!                 !  92-06  (M. Imbard)  periodic conditions on t and s
+   !!                 !  93-03  (M. Guyon)  symetrical conditions 
+   !!                 !  96-01  (G. Madec)  statement function for e3
+   !!                                       suppression of common work arrays
+   !!            8.5  !  02-06  (G. Madec)  free form F90
+   !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
@@ -9,5 +17,4 @@
    !!   tra_npc_init : initialization and control of the scheme
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and active tracers 
    USE dom_oce         ! ocean space and time domain
@@ -21,11 +28,10 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC tra_npc      ! routine called by step.F90
-
-   !! * Module variable
-   INTEGER ::       &
-      nnpc1 =   1,  &  ! nnpc1   non penetrative convective scheme frequency
-      nnpc2 =  15      ! nnpc2   non penetrative convective scheme print frequency
+   PUBLIC   tra_npc    ! routine called by step.F90
+
+   !!* Namelist namnpc: non penetrative convection algorithm
+   INTEGER ::   nnpc1 =   1   ! nnpc1   non penetrative convective scheme frequency
+   INTEGER ::   nnpc2 =  15   ! nnpc2   non penetrative convective scheme print frequency
+   NAMELIST/namnpc/ nnpc1, nnpc2
 
    !! * Substitutions
@@ -34,5 +40,5 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -50,50 +56,27 @@
       !!      iterations. instabilities are treated when the vertical density
       !!      gradient is less than 1.e-5.
-      !!
-      !!      'key_trdtra' defined: the trend associated with this
-      !!                               algorithm is saved.
-      !!
-      !!      macro-tasked on vertical slab (jj-loop)
+      !!      l_trdtra=T: the trend associated with this algorithm is saved.
       !!
       !! ** Action  : - (tn,sn) after the application od the npc scheme
       !!              - save the associated trends (ttrd,strd) ('key_trdtra')
       !!
-      !! References :
-      !!      Madec, et al., 1991, JPO, 21, 9, 1349-1371.
-      !!
-      !! History :
-      !!   1.0  !  90-09  (G. Madec)  Original code
-      !!        !  91-11  (G. Madec)
-      !!        !  92-06  (M. Imbard)  periodic conditions on t and s
-      !!        !  93-03  (M. Guyon)  symetrical conditions 
-      !!        !  96-01  (G. Madec)  statement function for e3
-      !!                                  suppression of common work arrays
-      !!   8.5  !  02-06  (G. Madec)  free form F90
-      !!   9.0  !  04-08  (C. Talandier) New trends organization
-      !!----------------------------------------------------------------------
-      !! * Modules used     
-      USE oce, ONLY :    ztdta => ua,   & ! use ua as 3D workspace   
-                         ztdsa => va      ! use va as 3D workspace   
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt       ! ocean time-step index
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk             ! dummy loop indices
-      INTEGER ::   &
-         inpcc ,                        & ! number of statically instable water column
-         inpci ,                        & ! number of iteration for npc scheme
-         jiter, jkdown, jkp,            & ! ???
-         ikbot, ik, ikup, ikdown          ! ???
-      REAL(wp) ::   &                     ! temporary arrays
-         ze3tot, zta, zsa, zraua, ze3dwn
-      REAL(wp), DIMENSION(jpi,jpk) ::   &
-         zwx, zwy, zwz                    ! temporary arrays
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-         zrhop                            ! temporary arrays
-      !!----------------------------------------------------------------------
-
-      IF( kt == nit000  )   CALL tra_npc_init
-
+      !! References : Madec, et al., 1991, JPO, 21, 9, 1349-1371.
+      !!----------------------------------------------------------------------
+      USE oce, ONLY :    ztrdt => ua   ! use ua as 3D workspace   
+      USE oce, ONLY :    ztrds => va   ! use va as 3D workspace   
+      !! 
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      INTEGER  ::   inpcc        ! number of statically instable water column
+      INTEGER  ::   inpci        ! number of iteration for npc scheme
+      INTEGER  ::   jiter, jkdown, jkp        ! ???
+      INTEGER  ::   ikbot, ik, ikup, ikdown   ! ???
+      REAL(wp) ::   ze3tot, zta, zsa, zraua, ze3dwn
+      REAL(wp), DIMENSION(jpi,jpk)     ::   zwx, zwy, zwz   ! 2D arrays
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zrhop           ! 3D arrays
+      !!----------------------------------------------------------------------
+
+      IF( kt == nit000  )   CALL tra_npc_init   ! Initialisation
 
       IF( MOD( kt, nnpc1 ) == 0 ) THEN
@@ -102,13 +85,10 @@
          inpci = 0
 
-         ! 0. Potential density
-         ! --------------------
-
-         CALL eos( tn, sn, rhd, zrhop )
-
-         ! Save tn and sn trends
-         IF( l_trdtra )   THEN
-            ztdta(:,:,:) = tn(:,:,:) 
-            ztdsa(:,:,:) = sn(:,:,:) 
+         CALL eos( tn, sn, rhd, zrhop )         ! Potential density
+
+
+         IF( l_trdtra )   THEN                  ! Save tn and sn trends
+            ztrdt(:,:,:) = tn(:,:,:) 
+            ztrds(:,:,:) = sn(:,:,:) 
          ENDIF
 
@@ -116,8 +96,6 @@
          DO jj = 1, jpj                                   !  Vertical slab
             !                                             ! ===============
-
-            ! 1. Static instability pointer 
-            ! -----------------------------
-
+            !  Static instability pointer 
+            ! ----------------------------
             DO jk = 1, jpkm1
                DO ji = 1, jpi
@@ -134,14 +112,14 @@
             END DO
             ! even if south-symmetric b. c. used, do not considere jj=1
-            IF( jj == 1 ) zwx(:,:) = 0.e0
+            IF( jj == 1 )   zwx(:,:) = 0.e0
 
             DO jk = 1, jpkm1
                DO ji = 1, jpi
                   zwx(ji,jk) = 1.
-                  IF( zwx(ji,jk) < 1.e-5 ) zwx(ji,jk)=0.
-               END DO
-            END DO
-
-            zwy(:,1) = 0.
+                  IF( zwx(ji,jk) < 1.e-5 ) zwx(ji,jk) = 0.e0
+               END DO
+            END DO
+
+            zwy(:,1) = 0.e0
             DO ji = 1, jpi
                DO jk = 1, jpkm1
@@ -150,5 +128,5 @@
             END DO
 
-            zwz(1,1) = 0.
+            zwz(1,1) = 0.e0
             DO ji = 1, jpi
                zwz(1,1) = zwz(1,1) + zwy(ji,1)
@@ -161,21 +139,14 @@
             ! ------------------------------------------------------------------
 
-            IF (zwz(1,1) /= 0.) THEN
-
-               ! -->> the density profil is statically instable :
-
+            IF( zwz(1,1) /= 0.e0 ) THEN         ! -->> the density profil is statically instable :
                DO ji = 1, jpi
-                  IF( zwy(ji,1) /= 0. ) THEN
-
-                     ! ikbot: ocean bottom level
-
-                     ikbot = mbathy(ji,jj)
-
-                     ! vertical iteration
-
-                     DO jiter = 1, jpk
-
+                  IF( zwy(ji,1) /= 0.e0 ) THEN
+                     !
+                     ikbot = mbathy(ji,jj)      ! ikbot: ocean bottom level
+                     !
+                     DO jiter = 1, jpk          ! vertical iteration
+                        !
                         ! search of ikup : the first static instability from the sea surface
-
+                        !
                         ik = 0
 220                     CONTINUE
@@ -183,17 +154,15 @@
                         IF( ik >= ikbot-1 ) GO TO 200
                         zwx(ji,ik) = zrhop(ji,jj,ik) - zrhop(ji,jj,ik+1)
-                        IF( zwx(ji,ik) <= 0. ) GO TO 220
+                        IF( zwx(ji,ik) <= 0.e0 ) GO TO 220
                         ikup = ik
                         ! the density profil is instable below ikup
-   
                         ! ikdown : bottom of the instable portion of the density profil
-
                         ! search of ikdown and vertical mixing from ikup to ikdown
-
+                        !
                         ze3tot= fse3t(ji,jj,ikup)
                         zta   = tn   (ji,jj,ikup)
                         zsa   = sn   (ji,jj,ikup)
                         zraua = zrhop(ji,jj,ikup)
-
+                        !
                         DO jkdown = ikup+1, ikbot-1
                            IF( zraua <= zrhop(ji,jj,jkdown) ) THEN
@@ -210,5 +179,5 @@
                         ikdown = ikbot-1
 240                     CONTINUE
-
+                        !
                         DO jkp = ikup, ikdown-1
                            tn(ji,jj,jkp) = zta
@@ -221,25 +190,18 @@
                            zrhop(ji,jj,ikdown) = zraua
                         ENDIF
-
                      END DO
                   ENDIF
 200               CONTINUE
                END DO
-
                ! <<-- no more static instability on slab jj
-
             ENDIF
             !                                             ! ===============
          END DO                                           !   End of slab
          !                                                ! ===============
-
-
-         ! save the trends for diagnostic
-         ! Non penetrative mixing trends
-         IF( l_trdtra )   THEN
-            ztdta(:,:,:) = tn(:,:,:) - ztdta(:,:,:)
-            ztdsa(:,:,:) = sn(:,:,:) - ztdsa(:,:,:)
-
-            CALL trd_mod(ztdta, ztdsa, jpttdnpc, 'TRA', kt)
+         ! 
+         IF( l_trdtra )   THEN         ! save the Non penetrative mixing trends for diagnostic
+            ztrdt(:,:,:) = tn(:,:,:) - ztrdt(:,:,:)
+            ztrds(:,:,:) = sn(:,:,:) - ztrds(:,:,:)
+            CALL trd_mod(ztrdt, ztrds, jptra_trd_npc, 'TRA', kt)
          ENDIF
       
@@ -252,12 +214,11 @@
          !  2. non penetrative convective scheme statistics
          !  -----------------------------------------------
-
          IF( nnpc2 /= 0 .AND. MOD( kt, nnpc2 ) == 0 ) THEN
             IF(lwp) WRITE(numout,*)' kt=',kt, ' number of statically instable',   &
-               ' water column : ',inpcc, ' number of iteration : ',inpci
+               &                   ' water column : ',inpcc, ' number of iteration : ',inpci
          ENDIF
-
+         !
       ENDIF
-      
+      !
    END SUBROUTINE tra_npc
 
@@ -268,33 +229,19 @@
       !!                   
       !! ** Purpose :   initializations of the non-penetrative adjustment scheme
-      !!
-      !! History :
-      !!   8.5  !  02-12  (G. Madec)  F90 : free form
-      !!----------------------------------------------------------------------
-      !! * Namelist
-      NAMELIST/namnpc/ nnpc1, nnpc2
-      !!----------------------------------------------------------------------
-
-      ! Namelist namzdf : vertical diffusion
-      REWIND( numnam )
+      !!----------------------------------------------------------------------
+      !
+      REWIND( numnam )           ! Namelist namzdf : vertical diffusion
       READ  ( numnam, namnpc )
-
-      ! Parameter print
-      ! ---------------
-      IF(lwp) THEN
+      !
+      IF(lwp) THEN               ! Namelist print
          WRITE(numout,*)
          WRITE(numout,*) 'tra_npc_init : Non Penetrative Convection (npc) scheme'
          WRITE(numout,*) '~~~~~~~~~~~~'
-         WRITE(numout,*) '          Namelist namnpc : set npc scheme parameters'
-         WRITE(numout,*)
-         WRITE(numout,*) '             npc scheme frequency           nnpc1  = ', nnpc1
-         WRITE(numout,*) '             npc scheme print frequency     nnpc2  = ', nnpc2
-         WRITE(numout,*)
+         WRITE(numout,*) '       Namelist namnpc : set npc scheme parameters'
+         WRITE(numout,*) '          npc scheme frequency           nnpc1  = ', nnpc1
+         WRITE(numout,*) '          npc scheme print frequency     nnpc2  = ', nnpc2
       ENDIF
-
-
-      ! Parameter controls
-      ! ------------------
-      IF ( nnpc1 == 0 ) THEN
+      !
+      IF ( nnpc1 == 0 ) THEN      ! Parameter controls
           IF(lwp) WRITE(numout,cform_war)
           IF(lwp) WRITE(numout,*) '             nnpc1 = ', nnpc1, ' is forced to 1'
@@ -302,5 +249,5 @@
           nwarn = nwarn + 1
       ENDIF
-      
+      !
    END SUBROUTINE tra_npc_init
 
